#pragma config(Hubs,  S1, HTServo,  HTMotor,  none,     none)
#pragma config(Sensor, S1,     ,               sensorI2CMuxController)
#pragma config(Sensor, S2,     ,               sensorSONAR)
#pragma config(Sensor, S3,     MICC,           sensorI2CCustom)
#pragma config(Sensor, S4,     MSDIST2,        sensorI2CCustomFastSkipStates9V)
#pragma config(Motor,  motorA,          m_head,        tmotorNXT, PIDControl, encoder)
#pragma config(Motor,  mtr_S1_C2_1,     motorD,        tmotorTetrix, openLoop)
#pragma config(Motor,  mtr_S1_C2_2,     motorE,        tmotorTetrix, openLoop)
#pragma config(Servo,  srvo_S1_C1_1,    head,                 tServoStandard)
#pragma config(Servo,  srvo_S1_C1_2,    left_h,               tServoStandard)
#pragma config(Servo,  srvo_S1_C1_3,    right_h,              tServoStandard)
#pragma config(Servo,  srvo_S1_C1_4,    servo4,               tServoNone)
#pragma config(Servo,  srvo_S1_C1_5,    servo5,               tServoStandard)
#pragma config(Servo,  srvo_S1_C1_6,    servo6,               tServoStandard)
//*!!Code automatically generated by 'ROBOTC' configuration wizard               !!*//

#include "microinfinity-cruizcore.h"
#include "mindsensors-irdist.h"
bool seen=false;
int i=0,count=0,v=0, kt=10;
float angel_ranged(float angleF)
{
	while(angleF>180)
		angleF=angleF-360;
	while(angleF<-180)
		angleF=angleF+360;
	return(angleF);
}

void right_h_up()
{
	for(i=50; i>0; i--)
	{
		servo(right_h)=i;
		wait1Msec(kt);
	}
}
void right_h_down()
{
	for(i=0; i<50; i++)
	{
		servo(right_h)=i;
		wait1Msec(kt);
	}

}
void left_h_down()
{
	for(i=200; i>120; i--)
	{
		servo(left_h)=i;
		wait1Msec(kt);
	}
}
void left_h_up()
{
	for(i=120; i<200; i++)
	{
		servo(left_h)=i;
		wait1Msec(kt);
	}
}
void head_right()
{
	for(i=135; i>45; i--)
	{
		servo(head)=i;
		wait1Msec(kt);
	}
}
void head_left()
{

	for(i=45; i<135; i++)
	{
		servo(head)=i;
		wait1Msec(kt);
	}
}
void povorot(int angle)
{
	short angleI = 0;
	float angleF = 0.0;
	float angleV=0.0;
	float last=0.0;
	float delta=0.9;
	float p=6.0;
	float d=3.0;
	float a=0.0;
	float k=0.000625;
	float v=1.0;
	angleI = MICCreadRelativeHeading(MICC);
	angleF = angleI / 100.0;
	angleV=angleF;
	clearTimer(T1);
	while(true)
	{
		angleI = MICCreadRelativeHeading(MICC);
		angleF = angleI / 100.0;
		angleV=angleV+sgn(angel_ranged(angle-angleV))*delta;
		displayTextLine(2, "Heading: %4.2f", angleF);
		v=angel_ranged(angleF-angleV)*p+angel_ranged(angleF-last)*d+angel_ranged(angleF-angleV)*angel_ranged(angleF-angleV)*sgn(angel_ranged(angleF-angleV))*k;
		if(fabs(angleF-angle)<=5 || time1[T1]>=6000) break;
		a=v*0.1*sgn(90-(angleF-angleV));
		if((abs(a))<10)
		{
			motor[motorE]=10*sgn(a);
			motor[motorD]=10*sgn(a);
		}
		else
		{
			motor[motorE]=a;
			motor[motorD]=a;
		}
		last=angleF;
		sleep(5);
	}
	motor[motorE]=0;
	motor[motorD]=0;
	sleep(100);
}

void hands(int time)
{
	int speed=30;
	int angle=10;
	count=0;
	nMotorEncoder[m_head]=0;
	clearTimer(T1);

	while(time1[T1]<time)
	{

		for(int i=10; i<speed; i++)
		{
			motor[m_head]=i;
			motor[motorB]=-2*i;
			motor[motorC]=3*i;
			wait1Msec(1);
		}
		clearTimer(T2);
		while(nMotorEncoder[m_head]<angle && time1[T2]<1000)
		{
			wait1Msec(1);
		}
		motor[m_head]=0;
		motor[motorB]=0;
		motor[motorC]=0;
		wait1Msec(10);
		for(int i=-10; i>-speed; i--)
		{
			motor[m_head]=i;
			motor[motorB]=-2*i;
			motor[motorC]=3*i;
			wait1Msec(1);
		}
		clearTimer(T2);
		while(nMotorEncoder[m_head]>-angle && time1[T2]<1000)
		{
			wait1Msec(1);
		}
		motor[m_head]=0;
		motor[motorB]=0;
		motor[motorC]=0;
		wait1Msec(10);
	}
}
void moves(tMotor name)
{
	int speed=20;
	int time=3000;
	int angle=10;
	count=0;
	nMotorEncoder[name]=0;
	clearTimer(T1);
	while(time1[T1]<time)
	{
		while(nMotorEncoder[name]<angle)
		{
			for(int i=10; i<speed; i++)
			{
				motor[name]=i;
				wait1Msec(1);
			}
			if((nMotorEncoder[m_head]-count)==0 && count!=0 && time1[T1]>1000)
			{
				break;
			}
			count=nMotorEncoder[m_head];
		}

		motor[name]=0;
		wait1Msec(10);

		while(nMotorEncoder[name]>-angle)
		{
			for(int i=-10; i>-speed; i--)
			{
				motor[name]=i;
				wait1Msec(1);
			}
			if((nMotorEncoder[m_head]-count)==0 && count!=0 && time1[T1]>2000)
			{
				break;
			}
			count=nMotorEncoder[m_head];
		}
		motor[name]=0;
		wait1Msec(10);
	}
}
task ears()
{
	hands(5000);
	motor[m_head]=0;
	moves(m_head);
	sleep(11000);
	moves(m_head);
	seen=true;
}
void rabbit()
{
	while((SensorValue[S2]>60 || SensorValue[S2]<20) || abs(SensorValue[S2]-count)>3)
	{
		displayCenteredBigTextLine(0, "%4d", SensorValue[S2] );
		count=SensorValue[S2];
		sleep(50);
	}
	povorot(60);
	startTask (ears);
	sleep(5000);
	sleep(3000);
	motor[motorB]=-10;
	sleep(2000);
	motor[motorB]=0;
	sleep(2000);
	motor[motorB]=10;
	sleep(2000);
	motor[motorB]=0;
	sleep(10);
	motor[motorC]=-10;
	sleep(2000);
	motor[motorC]=0;
	sleep(2000);
	motor[motorC]=10;
	sleep(2000);
	motor[motorC]=0;
	sleep(10);
	sleep(3000);
	stopTask(ears);
}

void bear()
{
	count=0;
	//playImmediateTone(soundBeepBeep);
	while((MSDISTreadDist(MSDIST2)>600 || MSDISTreadDist(MSDIST2)<70) || abs(MSDISTreadDist(MSDIST2)-count)>10)
	{
		displayCenteredBigTextLine(0, "%4dmm",MSDISTreadDist(MSDIST2) );
		count=MSDISTreadDist(MSDIST2);
		sleep(50);
	}
	povorot(-90);
	sleep(100);
	playSound(soundBeepBeep);
	kt=45;
	head_left();
	kt=32;
	right_h_up();
	sleep(2000);
	kt=24;
	right_h_down();
	kt=33;
	head_right();
	kt=31;
	left_h_up();
	kt=31;
	left_h_down();
	kt=24;
	right_h_up();
	kt=33;
	head_left();
	kt=5;
	right_h_down();
	kt=5;
	head_right();
}

task main()
{
	MICCsetRange8G(MICC);
	MICCreset(MICC);
	sleep(1000);

	while((MSDISTreadDist(MSDIST2)>500 || MSDISTreadDist(MSDIST2)<70) || abs(MSDISTreadDist(MSDIST2)-count)>3)
	{
		count=MSDISTreadDist(MSDIST2);
		sleep(50);
		displayCenteredBigTextLine(0, "%4dmm",MSDISTreadDist(MSDIST2) );
	}
	playSound(soundBeepBeep);
	rabbit();
	sleep(12000);
	povorot(-90);
	sleep(2000);
	povorot(-179);
	bear();
	/*	while(true)
	{
	displayCenteredBigTextLine(0, "%4dmm",MSDISTreadDist(MSDIST2) );
	}*/
}
